src/k9/routes/web.php
<?php

use App\Http\Controllers\Auth\NewPasswordController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\ApprentiController;
use App\Http\Controllers\BackendController;
use App\Http\Controllers\OffreController;
use App\Http\Controllers\EntrepriseController;
use App\Http\Controllers\UserController;
use App\Http\Controllers\AptitudeController;
use App\Http\Controllers\BulletinController;
use App\Http\Controllers\OptionController;
use App\Http\Controllers\PromotionController;
use App\Http\Controllers\PromotionEleveController;
use App\Http\Controllers\EntretienController;
use App\Http\Controllers\ProfesseurController;
use App\Http\Controllers\FicheController;
use App\Http\Controllers\MatiereController;
use App\Http\Controllers\NoteController;
use App\Http\Controllers\OffreEntreprise;
use App\Http\Controllers\PeriodeController;
use App\Http\Controllers\RdController;
use App\Http\Controllers\TuteurController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/first-password/{token}', [NewPasswordController::class, 'first'])->name('password.first');
    
// Groupe de routes avec uniquement le middleware d'authentification (connecté au site) //
Route::middleware(['auth', 'firstlogin'])->group(function () {
    Route::get('/mentions', [BackendController::class, 'mentions'])->name('mentions');
    Route::get('/', [OffreController::class, 'welcome'])->name('welcome');
    Route::get('profil', [UserController::class, 'profil'])->name('profil');
    Route::post('profil', [UserController::class, 'profilUpdate'])->name('profilUpdate');
    Route::resource('offre_entreprise', OffreEntreprise::class);
});
// Groupe de routes pour les professeurs avec middelware
Route::middleware(['auth', 'firstlogin', 'professeur'])->prefix('professeur')->group(function () {
    Route::get('/', [BackendController::class, 'profDashboard'])->name('profdashboard');
    Route::get('/matiereProfesseur', [MatiereController::class, 'matiereProfesseur'])->name('matiereProfesseur');
    Route::get('/promotionProfesseur', [PromotionController::class, 'promotionProfesseur'])->name('promotionProfesseur');
    Route::resource('notes', NoteController::class)->except(['show']);
    Route::get('notes/create/matieres/{promotion_id}', [NoteController::class, 'createMatieres'])->name('notes.create.matieres');
    Route::get('notes/create/apprentis/{promotion_id}', [NoteController::class, 'createApprentis'])->name('notes.create.apprentis');
    Route::get('notes/create/periodes/{promotion_id}', [NoteController::class, 'createPeriodes'])->name('notes.create.periodes');
});
// Groupe de routes avec le middleware d'authentification et celui d'admin du site //
Route::middleware(['auth','admin', 'firstlogin'])->group(function () {
    Route::get('fiche/pdf', [FicheController::class, 'testViewPDF'])->name('testViewPDF');
    Route::get('fiche/export/{id}', [FicheController::class, 'getPostPdf'])->name('getPostPdf');
    Route::post('/tuteur_entreprise', [OffreController::class, 'tuteurEntreprise'])->name('tuteur_entreprise');
    Route::post('/download', [BackendController::class, 'download'])->name('download');
    Route::post('/contact', [BackendController::class, 'contact'])->name('contact');
    /* Changer ces routes dans le rd */
    Route::post('/promotionPeriode', [PeriodeController::class, 'promotionPeriode'])->name('promotionPeriode');
    Route::post('/promotionApprenti', [PromotionController::class, 'promotionApprenti'])->name('promotionApprenti');
    Route::get('/bulletinPromotion', [BulletinController::class, 'bulletinPromotion'])->name('bulletinPromotion');
    Route::post('/bulletinMatiere', [BulletinController::class, 'bulletinMatiere'])->name('bulletinMatiere');
    Route::post('/promotionMatiere',[PromotionController::class, 'promotionMatiere'])->name('promotionMatiere');
    /* */
    Route::prefix('admin')->group(function () {
        Route::resource('aptitudes', AptitudeController::class);
        Route::resource('offres', OffreController::class);
        Route::resource('entreprises', EntrepriseController::class);
        Route::resource('tuteurs', TuteurController::class);
        Route::resource('users', UserController::class);
        Route::resource('options', OptionController::class);
        Route::resource('promotions', PromotionController::class);
        Route::resource('apprenti', ApprentiController::class);
        Route::resource('eleve_promotion', PromotionEleveController::class);
        Route::resource('entretiens', EntretienController::class);
        Route::resource('professeur', ProfesseurController::class);
        Route::resource('fiches', FicheController::class);
        Route::resource('rd', RdController::class);
        Route::resource('matieres',MatiereController::class);
        Route::resource('periodes',PeriodeController::class);
        // A changer dans rd
        Route::resource('bulletins',BulletinController::class);
        Route::get('/', [BackendController::class, 'dashboard'])->name('dashboard');
    });
});
require __DIR__ . '/auth.php';

src/k9/app/Models/Entretien.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Entretien extends Model
{
    use HasFactory;

    protected $fillable = ['date_entretien', 'decision', 'apprenti_id', 'fiche_id', 'rd_id','promotion_id','entretien_id'];

    public function apprenti()
    {
      return $this->belongsTo(Apprenti::class);
    }

    public function rd()
    {
      return $this->belongsTo(RD::class);
  }

  public function fiche()
  {
    return $this->belongsTo(Fiche::class);
  }

  public function promotion()
  {
    return $this->belongsTo(Promotion::class);
  }
}

src/k9/app/Http/Controllers/EntretienController.php
<?php

namespace App\Http\Controllers;

use App\Models\{Entretien, Apprenti, Professeur, ElevePromotion, Promotion, Rd,Fiche};
use Exception;
use Illuminate\Http\Request;


class EntretienController extends Controller
{
  /**
   * Display a listing of the resource.
   *
   * @return \Illuminate\Http\Response
   */
  public function index()
  {
    $entretiens = Entretien::all();
    return view('entretiens/index', compact('entretiens'));
  }

  /**
   * Show the form for creating a new resource.
   *
   * @return \Illuminate\Http\Response
   */
  public function create()
  {
    $rds = Rd::all();
    $apprentis = Apprenti::all();
    $promotions = Promotion::all();
    return view('entretiens/create', compact('rds', 'apprentis', 'promotions'));
  }

  /**
   * Store a newly created resource in storage.
   *
   * @param  \Illuminate\Http\Request  $request
   * @return \Illuminate\Http\Response
   */
  public function store(Request $request)
  {
    $data = request()->validate([
      'date_entretien' => 'required',
      'decision' => 'required',
      'apprenti_id' => 'required',
      'rd_id' => 'required',
      'promotion_id' => 'required',
    ]);
    Entretien::create($data);
    return redirect()->route('entretiens.index')->with('success', 'Entretien créé');
  }

  /**
   * Display the specified resource.
   *
   * @param  \App\Models\Entretien  $entretien
   * @return \Illuminate\Http\Response
   */
  public function show(Entretien $entretien)
  {
    return view('entretiens.show', compact('entretien'));
  }

  /**
   * Show the form for editing the specified resource.
   *
   * @param  \App\Models\Entretien  $entretien
   * @return \Illuminate\Http\Response
   */
  public function edit(Entretien $entretien)
  {
    $rds = Rd::all();
    $apprentis = Apprenti::all();
    $promotions = Promotion::all();
    return view('entretiens/edit', compact('rds', 'apprentis', 'promotions','entretien'));
  }

  /**
   * Update the specified resource in storage.
   *
   * @param  \Illuminate\Http\Request  $request
   * @param  \App\Models\Entretien  $entretien
   * @return \Illuminate\Http\Response
   */
  public function update(Request $request, Entretien $entretien)
  {
    $data = $request->validate([
      'date_entretien' => 'required',
      'decision' => 'required',
      'apprenti_id' => 'required',
      'rd_id' => 'required',
      'promotion_id' => 'required',
    ]);
    $entretien->update($data);
    return redirect()->route('entretiens.index')->with('success', 'Entretien modifié');
  }

  /**
   * Remove the specified resource from storage.
   *
   * @param  \App\Models\Entretien  $entretien
   * @return \Illuminate\Http\Response
   */
  public function destroy(Entretien $entretien)
  {
    try {
      $entretien->delete();
      return redirect()->route('entretiens.index')->with('success', 'Entretien supprimé');
    } catch (Exception $e) {
      $msg = "";
      switch ($e->getCode()) {
        case 23000:
            $msg ="L'élément ne peut etre supprimé car il est lié à un autre élément";
            break;      
        default:
            $msg = $e->getMessage();
            break;
      }
      return redirect()->back()->withErrors($msg);
    }
  }
}

src/k9/resources/views/Entretiens/create.blade.php
@extends('backend.template')

@section('content')
<div class="row">
    <div class="col-lg-12 margin-tb">
        <div class="float-start">
            <h2>Ajouter un nouvel entretien</h2>
        </div>
        <div class="float-end">
            <a class="btn btn-outline-primary" href="{{ route('entretiens.index') }}">Retour </a>
        </div>
    </div>
</div>
   
@if ($errors->any())
    <div class="alert alert-danger">
        <strong>Oups !</strong> Il y a plusieurs problèmes avec vos saisies.<br><br>
        <ul>
            @foreach ($errors->all() as $error)
                <li>{{ $error }}</li>
            @endforeach
        </ul>
    </div>
@endif
   
<form action="{{ route('entretiens.store') }}" method="POST">
    @csrf
     <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12">
          <div class="form-group">
            <a class="font-bold">Date d'entretien :</a>
            <input type="date" name="date_entretien" class="form-control" value="{{Carbon\Carbon::now()->format('Y-m-d')}}">
          </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
          <div class="form-group">
            <a class="font-bold">Décision :</a>
            <select class="form-select" name="decision">
              <option value="2">Accepté</option>
              <option value="1">En cours</option>
              <option value="0">Refusé</option>
            </select>
          </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
          <div class="form-group">
            <a class="font-bold">Responsable de dispositif :</a>
            <select class="form-select" name="rd_id">
              @foreach($rds as $rd)
                <option value="{{$rd->id}}">{{ $rd->user->nom . " " . $rd->user->prenom}} </option>
              @endforeach
          </select>
          </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
          <div class="form-group">
            <a class="font-bold">Apprenti :</a>
            <select class="form-select" name="apprenti_id">
              @foreach($apprentis as $apprenti)
                <option value="{{$apprenti->id}}">{{ $apprenti->user->nom . " " . $apprenti->user->prenom}}</option>
              @endforeach
            </select>
          </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
          <div class="form-group">
            <a class="font-bold">Promotion :</a>
            <select class="form-select" name="promotion_id">
                @foreach ($promotions as $p )
                    <option value="{{$p->id}}">{{ $p->libelle }}</option>
                @endforeach
            </select>
          </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12 text-center">
          <button type="submit" class="btn btn-primary">Envoyer</button>
        </div>
    </div>
   
</form>
@endsection

src/k9/resources/views/Entretiens/edit.blade.php
@extends('backend.template')

@section('title')
    Modifier entretien
@endsection

@section('content')
    <div class="row">
        <div class="col-lg-12 margin-tb">
            <div class="float-start">
                <h2>Modifier l'entretien</h2>
            </div>
            <div class="float-end">
                <a class="btn btn-outline-primary" href="{{ route('entretiens.index') }}"> Retour</a>
            </div>
        </div>
    </div>

    @if ($errors->any())
        <div class="alert alert-danger">
            Une erreur est survenue..<br>
            <ul>
                @foreach ($errors->all() as $error)
                    <li>{{ $error }}</li>
                @endforeach
            </ul>
        </div>
    @endif


    <form method="POST" action="{{ route('entretiens.update', $entretien) }}">
        @csrf
        @method('PUT')
        <div class="row">
            <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Date d'entretien :</strong>
                    <input type="date" name="date_entretien" class="form-control"value="{{ $entretien->date_entretien }}">
                </div>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Décision :</strong>
                    <select class="form-select" name="decision">
                        <option value="2" @if ($entretien->decision)
                            selected="selected"
                            @endif
                            >Accepté
                        </option>
                        <option value="1" @if (!$entretien->decision)
                            selected="selected"
                            @endif
                            >Refusé
                        </option>
                        <option value="0" @if ($entretien->decision)
                            selected="selected"
                            @endif
                            >En cours
                        </option>
                    </select>
                </div>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Responsable de dispositif :</strong>
                    <select class="form-select" name="rd_id">
                        @foreach ($rds as $rd)
                            <option value="{{ $rd->id }}" 
                                @if ($rd->id == $entretien->rd->id)
                                selected="selected"
                                @endif
                            >{{ $rd->user->nom . ' ' . $rd->user->prenom }} 
                            </option>
                        @endforeach
                    </select>
                </div>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Apprenti :</strong>
                    <select class="form-select" name="apprenti_id">
                        @foreach ($apprentis as $apprenti)
                            <option value="{{ $apprenti->id }}" @if ($apprenti->id == $entretien->apprenti->id)
                                selected="selected"
                        @endif
                        >{{ $apprenti->user->nom . ' ' . $apprenti->user->prenom }}</option>
                        @endforeach
                    </select>
                </div>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12">
                <div class="form-group">
                    <strong>Promotion :</strong>
                    <select class="form-select" name="promotion_id">
                        @foreach ($promotions as $promotion)
                            <option value="{{ $promotion->id }}" @if ($promotion->id == $entretien->promotion->id)
                                selected="selected"
                        @endif
                        >{{ $promotion->libelle }}</option>
                        @endforeach
                    </select>
                </div>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12 text-center">
                <button type="submit" class="btn btn-primary">Envoyer</button>
            </div>
        </div>

    </form>
@endsection

src/k9/resources/views/Entretiens/index.blade.php
@extends('backend.template')

@section('content')
    <div class="row">
        <div class="col-lg-12 margin-tb">
            <div class="float-start">
                <h2>CRUD Entretiens</h2>
            </div>
            <div class="float-end">
                <a class="btn btn-outline-success" href="{{ route('entretiens.create') }}"> Créer un Entretien</a>
            </div>
            <div class="float-end">
                <a class="btn btn-outline-success" href="{{ route('fiches.create') }}"> Remplir une fiche</a>
            </div>
        </div>
    </div>
   
    @if ($message = Session::get('success'))
        <div class="alert alert-success">
            <p>{{ $message }}</p>
        </div>
    @elseif($errors->any())
        <div class="alert alert-warning">
            {{$errors->first()}}
        </div>
    @endif
   
    <div class="padd20">
        <table class="table table-bordered" id="example">
            <thead>
                <th>Date d'entretien</th>
                <th>Decision</th>
                <th>RD</th>
                <th>Eleve</th>
                <th>Promotion</th>
                <th>Fiche</th>
                <th width="280px">Action</th>
            </thead> 
            <tbody>   
                @foreach ($entretiens as $e)
                <tr>
                    <td>{{\Carbon\Carbon::parse($e->date_entretien)->format('d/m/Y')}}</td>
                    @if ($e->decision == 2)
                    <td>Accepté</td>
                    @elseif ($e->decision == 1)
                    <td>En cours</td>
                    @elseif ($e->decision == 0)
                    <td>Refusé</td>
                    @endif
                    <td>{{$e->rd->user->prenom . " " . $e->rd->user->nom}}</td>
                    <td>{{$e->apprenti->user->prenom . " " . $e->apprenti->user->nom}}</td>
                    <td>{{$e->promotion->libelle}}</td>
                    <td>@if ($e->fiche_id != null)
                        <p><a class="btn btn-outline-sucess btn-pdf" href="{{ route('getPostPdf',$e->fiche_id) }}"></a></p>
                        @else
                        <p>Pas de fiche créée</p>
                        @endif
                    </td>
                    <td class="actions">
                        <a class="btn btn-edit col" href="{{ route('entretiens.edit',$e->id) }}"></a>
                        <a class="btn btn-show col" href="{{ route('entretiens.show',$e->id) }}"></a>
                        <button type="button" class="btn btn-delete col" data-bs-toggle="modal" data-bs-target="#{{ "modal-".$e->id}}"></button>
                        <form action="{{ route('entretiens.destroy',$e->id) }}" method="POST" class="col">
                            @csrf
                            @method('DELETE')
                           <!-- Modal Suppression-->
                            <div class="modal fade" id="{{ "modal-".$e->id}}" tabindex="-1" aria-labelledby="{{ "modalLabel-".$e->id}}" aria-hidden="true">
                                <div class="modal-dialog">
                                    <div class="modal-content">
                                    <div class="modal-header">
                                        <h5 class="modal-title" id="{{ "modalLabel-".$e->id}}">
                                            Supression Entretien</h5>
                                        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                                    </div>
                                    <div class="modal-body">
                                        Voulez-vous vraiment supprimer cet entretien?
                                    </div>
                                    <div class="modal-footer">
                                        <button type="button" class="btn-modal btn-secondary" data-bs-dismiss="modal">Fermer</button>
                                        <button type="submit" class="btn-modal btn-primary">Supprimer</button>
                                    </div>
                                    </div>
                                </div>
                            </div>
                        </form>
                    </td>
                </tr>
                @endforeach
            </tbody>    
        </table>     
    </div> 
@endsection

src/k9/resources/views/Entretiens/show.blade.php
@extends('backend.template')
  
@section('content')
    <div class="row">
        <div class="col-lg-12 margin-tb">
            <div class="float-start">
                <h2> Afficher l'entretien</h2>
            </div>
            <div class="float-end">
                <a class="btn btn-outline-primary" href="{{ route('entretiens.index') }}">Retour </a>
            </div>
        </div>
    </div>
   
    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <a class="font-bold">Date :</a>
                {{ $entretien->date_entretien }}
            </div>
            <div class="form-group">
                <a class="font-bold">Décision :</a>
                {{ $entretien->decision ? "Accepté" : "Refusé" }}
            </div>
            <div class="form-group">
                <a class="font-bold">Responsable de dispositif concerné :</a>
                {{ $entretien->rd->user->prenom .' '.$entretien->rd->user->nom }}
            </div>
            <div class="form-group">
                <a class="font-bold">Apprenti concerné :</a>
                {{ $entretien->apprenti->user->prenom.' '.$entretien->apprenti->user->nom }}
            </div>
            <div class="form-group">
                <a class="font-bold">Promotion concernée :</a>
                {{ $entretien->promotion->libelle }}
            </div>
        </div>
    </div>
@endsection